<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Download_multi                                             |
// | Mod Version : 0.8                                                     |
// | Mod Orignal author: Tboris                                            |
// | Mod Second author : Cestlodovic                                       |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module est bas sur le module existant pour le tlchargement,     |
// | cette version permet le tlchargement sur plusieurs pages.           |
// | Mod Addon : PclZip -> http://www.phpconcept.net/pclzip/               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class DownloadMulti
{
  var $plugin_name, $plugin_path, $plugin_url;
  var $my_config;
  
  function DownloadMulti($plugin_name, $plugin_path, $plugin_url)
  {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }

  function initialize_event_handler()
  {
    global $user;
    $this->load_config(); // Chargement de la configuration
    $this->load_lang(); // Chargement des langues

    // Si l'utilisateur est diffrent de guest
    // alors on affiche les lments du plugin
    if (!$user['is_the_guest'])
    {
      add_event_handler('loc_end_page_header', array(&$this, 'DmHeader')); // Ajout d'lements dans le header

      // ---- Thumbnail
      add_event_handler('loc_begin_index_thumbnails', array(&$this, 'DmFormThumbnail')); // Entre HTML du formulaire pour la slection des images

      add_event_handler('loc_index_thumbnail', array(&$this, 'DmCategoryThumbnail')); // Affichage des cases  cocher sous les vignettes
      add_event_handler('loc_begin_index_thumbnails', array(&$this, 'DmCategoryDefault')); // Affichage du cadre en bas de thumbnail.tpl
      
      if (script_basename() == 'popuphelp')
      {
        // ---- Aide
        add_event_handler('get_popup_help_content', array(&$this, 'get_popup_help_content'), EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
      }
    }

    if (is_admin())
    {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu du menu d'administration
    }
  }
  
  // Chargement de la configuration
  function load_config()
  {
    $x = @file_get_contents( $this->plugin_path.'/data.dat' );
    if ($x!==false)
    {
      $c = unserialize($x);
      // do some more tests here
      $this->my_config = $c;
    }

    if ( !isset($this->my_config)
      or empty($this->my_config['rep_pwg']) )
    {
      $this->my_config['comment'] = '';
      $this->my_config['group_id'] = 1;
      $this->my_config['archive_size'] = 3145728;
      $this->my_config['prefix'] = 'photos_';
      $this->my_config['prefix_dir'] = 'hilaire';
      $this->my_config['active_msg'] = true;
      $this->save_config();
    }
  }

  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu)
  {
    array_push($menu,
      array(
        'NAME' => 'Download Multi',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'/admin/DmAdmin.php')
      )
    );
    return $menu;
  }
  
  // Sauvegarde de la configuration
  function save_config()
  {
    $file = fopen( $this->plugin_path.'/data.dat', 'w' );
    fwrite($file, serialize($this->my_config) );
    fclose( $file );
  }
  
  // Chargement des fichiers langues
  function load_lang()
  {
    global $lang;
    include(get_language_filepath('plugin.lang.php', $this->plugin_path) );
  }

  // Gestion de l'aide pour le plugin
  function get_popup_help_content($popup_help_content, $page)
  {
    if (in_array($page, array($this->plugin_name, 'DownloadMulti')))
    {
      $help_content =
      @file_get_contents(get_language_filepath('help/'.$page.'.html', $this->plugin_path));
    }
    else
    {
      $help_content = false;
    }

    if ($help_content == false)
    {
      return $popup_help_content;
    }
    else
    {
      return $popup_help_content.$help_content;
    }
  }
  
/* ------ Function pour la gestion du formulaire sous les vignettes ------- */

  // Chargement de fichier dans l'entte du template
  function DmHeader()
  {
    global $template;
    $DmUrlCss = $this->plugin_url.'plugins/'.$this->plugin_name.'/template/DownloadMulti.css';
    $DmUrlJs = $this->plugin_url.'plugins/'.$this->plugin_name.'/include/DownloadMulti.js';
    $template->assign_block_vars('head_element',
      array(
        'CONTENT' => '<link rel="stylesheet" type="text/css" href="'.$DmUrlCss.'"><script type="text/javascript" src="'.$DmUrlJs.'"></script>'
      )
    );
  }
  
  // Affiche l'entre HTML du formulaire
  function DmFormThumbnail()
  {
    global $template;
    // Cration de l'url
    $DmUrlPost = duplicate_index_URL();
    $template->concat_var('PLUGIN_INDEX_CONTENT_BEGIN', '<form id="dl" action="'.$DmUrlPost.'" name="DmForm" method="post">');
  }
  
  // Affiche les cases  cocher derrire le nom de l'image
  // $row['id'] est l'identifiant de l'image
  function DmCategoryThumbnail($row)
  {
    global $template;

    $template->assign_block_vars('thumbnails.line.thumbnail.element_name',
      array(
        'NAME' => '<input type="checkbox" name="id_images[]" value="'.$row['id'].'">'
      )
    );
  }
  
  // Affichage du formulaire sous les vignettes
  function DmCategoryDefault()
  {
    global $user, $template, $conf, $prefixeTable, $page, $lang;
    
    @$action = $_POST['action'];

    switch($action)
    {
      case 'add':
        $this->DmControle();
      break;
      
      case 'del':
        $this->DmDelete();
      break;
    }
    
    if($user['id'] <> 2)
    {
      // Intgration du formulaire sous les images
      $template->set_filenames(
        array('DownloadMulti_category' => $this->plugin_path.'/template/DmCategory.tpl')
      );

      // Rcupration du groupe utilisateur autoris  tlcharger les images
      $query = '
          SELECT group_id
          FROM '.USER_GROUP_TABLE.'
          WHERE user_id = '.$user['id'].'
      ;';
      $result = pwg_query($query);

      while($row = mysql_fetch_array($result))
      {
        // Compare le groupe de l'utilisateur avec le groupe
        // authoris  tlcharger
        if ( $row['group_id'] == $this->my_config['group_id'] )
        {
          $redirect_to = isset($_POST['redirect']) ? $_POST['redirect'] : '';

          // Titre du bloc en bas de la des vignettes
          $template->assign_var('DlMulti_TITLE', $lang['dl_title']);

          // Compte le nombre de lignes pour le visiteur
          $query = '
            SELECT COUNT(*) AS nb_line
            FROM '.$prefixeTable.'download_multi
            WHERE id_user = '.$user['id'].'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          // Si le nombre de lignes est suprieur  0
          // alors on affiche le message d'avertissement
          // utilisateur
          if ($row['nb_line'] > 0)
          {
            $template->assign_block_vars('check',
              array(
                'NB' => $row['nb_line'],
                'POST' => duplicate_index_URL()
              )
            );
          }

          // Si la page de dpart est une catgorie
          // on gre l'affichage ou non du tlchargement
          // des images hautes dfinitions
          if (isset($page['category']['name']))
          {
            // Slection du rpetoire de base pour la
            // catgorie en cours de visite
            // Permet de contrler la prsence du
            // rpertoire pwg_high
            // si il y est prsent alors on affiche la
            // possibilit de tlcharger les images
            // hautes dfinitions
            $query1 = '
              SELECT dir, id_uppercat
              FROM '.CATEGORIES_TABLE.'
              WHERE id = '.$page['category']['id'].'
            ;';

            $row1 = mysql_fetch_array(pwg_query($query1));

            $uppercat = $row1['id_uppercat'];
            $path = $row1['dir'];

            // Contrle de l'existance et rcupration
            // des informations pour la gestion des
            // haute dfinition dans les sous-catgories
            while (!is_null($uppercat))
            {
              $query2 = '
                SELECT dir, id_uppercat
                FROM '.CATEGORIES_TABLE.'
                WHERE id = '.$uppercat.'
              ;';
            
              $row2 = mysql_fetch_array(pwg_query($query2));
              $uppercat = $row2['id_uppercat'];
              $path = $row2['dir'].'/'.$path;
            }
            
            $template->assign_block_vars('form',
              array(
                'INPUT_VALUE_NORMAL' => 'normal',
                'INPUT_VALUE_THUMBNAIL' => 'thumbnail',
                'POSTPREVIEW' => $this->plugin_url.'plugins/'.$this->plugin_name.'/include/DmPreview.php',
                'POSTPANIER' => $this->plugin_url.'plugins/'.$this->plugin_name.'/include/DmPanier.php?action=name',
                'CATEGORY' => $page['category']['name'],
              )
            );

            // Si il n'y a aucun images en hautes dfinitions
            // ou l'utilisateur n'a pas le droit aux hautes dfinitions
            // alors la ligne de tlchargement des hautes dfinitions
            // ne s'affiche pas
            if(is_dir(PHPWG_ROOT_PATH.'/galleries/'.$row1['dir'].'/pwg_high')
            and ($user['enabled_high'] == 'true'))
            {
              $template->assign_block_vars('form.high',
                array(
                  'INPUT_VALUE_HIGH' => 'high',
                )
              );
            }
          }
          else
          {
            $template->assign_block_vars('form',
              array(
                'INPUT_VALUE_NORMAL' => 'normal',
                'INPUT_VALUE_THUMBNAIL' => 'thumbnail',
                'POSTPREVIEW' => $this->plugin_url.'plugins/'.$this->plugin_name.'/include/DmPreview.php',
                'POSTPANIER' => $this->plugin_url.'plugins/'.$this->plugin_name.'/include/DmPanier.php?action=name',
              )
            );

            // Si l'utilisateur n'a droit aux hautes dfinitions
            // la possibilit de tlcharger les hautes dfinitions
            // s'affiche
            if($user['enabled_high'] == 'true')
            {
              $template->assign_block_vars('form.high',
                array(
                  'INPUT_VALUE_HIGH' => 'high',
                )
              );
            }
          }
        }
      }

      // Gestion du template
      $dm_html = $template->parse('DownloadMulti_category', true);
      $template->concat_var('PLUGIN_INDEX_CONTENT_END', $dm_html);
    }
  }

  // Contrle les valeurs envoys par le formulaire
  // Cr les rpertoires zip_archive et celui de l'utilisateur
  // si ils n'existent pas
  function DmControle()
  {
    global $template, $lang, $user;
    
    @$id_images = $_POST['id_images'];
    @$mode = $_POST['mode'];
    $DmErreurs = 0;

    // Test si au moins une image  t
    // slectionn
    if(!isset($id_images))
    {
      $DmErreurs = 1;
      $template->assign_block_vars(
        'erreurs',
          array(
            'LIST_ERREUR' => $lang['dl_title_erreur'],
          )
        );
        
      $template->assign_block_vars(
        'erreurs.images',
          array(
            'EMPTY_IMAGE' => $lang['dl_choice_image'],
          )
        );
    }

    // Test le rpertoire zip_archive
    // Si il n'existe pas le script le cr
    // Action ncessaire pour rsoudre le problme de droit chez certains hbergeurs
    $dir = $this->plugin_path;
    if(!is_dir($dir.'/zip_archive/'))
    {
      umask(0000);
      if(!mkdir($dir.'/zip_archive/', 0777))
      {
        $DmErreurs = 1;
        $template->assign_block_vars(
          'erreurs',
            array(
              'LIST_ERREUR' => $lang['dl_title_erreur'],
            )
          );
        
        $template->assign_block_vars(
          'erreurs.dir',
            array(
              'DIR_ERROR' => $lang['dl_dir_zip'],
            )
          );
      }
    }
    
    // Cration du rpertoire de l'utilisateur avec sont id user
    if(!is_dir($dir.'/zip_archive/'.$user['id']))
    {
      $DmErreurs = 1;
      umask(0000);
      if(!mkdir($dir.'/zip_archive/'.$user['id'], 0777))
      {
        $template->assign_block_vars(
          'erreurs',
            array(
              'LIST_ERREUR' => $lang['dl_title_erreur'],
            )
          );
          
        $template->assign_block_vars(
          'erreurs.dir',
            array(
              'DIR_ERROR' => $lang['dl_dir_zip'],
            )
          );
      }
    }
    clearstatcache();
    
    // Si il n'y a aucunes erreurs
    // on continue l'ajout dans la panier
    if($DmErreurs != 1)
    {
      $this->DmAddPicture($id_images, $mode);
    }
  }
  
  /* Ajoute les images dans le panier
  *  $id_images --> Liste des images slectionns
  *  $mode      --> Type d'images ajouter (thumbnail, normal, high) */
  function DmAddPicture($id_images, $mode)
  {
    global $conf, $user, $prefixeTable;
    
    switch($mode)
    {
      case 'thumbnail':
        // Insertion des vignettes dans la base de donnes
        for($i=0;$i<count($id_images);$i++)
        {
          // Slection des informations sur l'image
          $query = '
            SELECT file, path
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          // Contrle si l'image est un fichier distant
          if (substr($row['path'], 0, 4) != 'http')
          {
            $dir = dirname($row['path']);
            $file = $dir.'/thumbnail/'.$conf['prefix_thumbnail'].$row['file'];

            // Taille de l'image
            $fic_size = filesize($file);

            $query = '
              INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
              VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'t\')
              ON DUPLICATE KEY UPDATE
                id_user = \''.$user['id'].'\'
                AND id_image = \''.$id_images[$i].'\'
                AND type = \'t\'
              ;';
            $result = pwg_query($query);
          }
        }
        break;
        
      case 'normal':
        // Insertion des photos normal dans la base de donnes
        for($i=0;$i<count($id_images);$i++)
        {
          // Slection des informations sur l'image
          $query = '
            SELECT file, path
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          // Contrle si l'image est un fichier distant
          if (substr($row['path'], 0, 4) != 'http')
          {
            $dir = dirname($row['path']);
            $file = $dir.'/'.$row['file'];

            // Taille de l'image
            $fic_size = filesize($file);

            $query = '
              INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
              VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'n\')
              ON DUPLICATE KEY UPDATE
                id_user = \''.$user['id'].'\'
                AND id_image = \''.$id_images[$i].'\'
                AND type = \'n\'
            ;';
            $result = pwg_query($query);
          }
        }
        break;

      case 'high':
        // Insertion des haut dfinition dans la base de donnes
        for($i=0;$i<count($id_images);$i++)
        {
          // Slection des informations sur l'image
          $query = '
            SELECT file, path
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          // Contrle si l'image est un fichier distant
          if (substr($row['path'], 0, 4) != 'http')
          {
            $dir = dirname($row['path']);
            $file = $dir.'/pwg_high/'.$row['file'];
            
            // contrle si le fichier existe, dans le cas contraire
            // rien n'est insr et le traitement continue sur les images suivantes.
            if(file_exists($file))
            {
              // Taille de l'image
              $fic_size = filesize($file);

              $query = '
                INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
                VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'h\')
                ON DUPLICATE KEY UPDATE
                  id_user = \''.$user['id'].'\'
                  AND id_image = \''.$id_images[$i].'\'
                  AND type = \'h\'
              ;';
              $result = pwg_query($query);
            }
          }
        }
      break;
    }
  }
  
  // Vide le panier en cours
  function DmDelete()
  {
    global $user, $prefixeTable;
    // Suppression des images slectionn dans une prcdente session
    $query = '
      DELETE FROM '.$prefixeTable.'download_multi
      WHERE id_user = \''.$user['id'].'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour viter la fragmentation
    // aprs suppression d'enregistrements
    $query = '
      OPTIMIZE TABLE '.$prefixeTable.'download_multi
    ;';
    $result = pwg_query($query);

    // Suppression de tout les fichiers
    // dans le rpertoire utilisateur
    $dir_zip = $this->plugin_path.'/zip_archive/'.$user['id'].'/';
    $dir = opendir($dir_zip);
    while($file = readdir($dir))
    {
      if(!is_file($file) && $file != '.' && $file != '..')
      {
        if(!unlink($dir_zip.$file))
        {
          $template->assign_block_vars(
            'erreurs',
              array(
                'LIST_ERREUR' => $lang['dl_title_erreur'],
              )
            );

          $template->assign_block_vars(
            'erreurs.dir',
              array(
                'DIR_ERROR' => $lang['dl_dir_zip'],
              )
            );
        }
      }
    }
    clearstatcache();
  }

/*------- Section pour le fichier DmPanier.php ------- */

  /* Prfix des fichiers zip gnrs
  * Si l'utilisateur vient de la page thumbnail
  * il lui est demander de saisir un nom pour
  * la gnration des fichiers zip */
  function DmPanierPrefixZip()
  {
    global $template;

    $template->assign_block_vars(
                'telechargement.name',
                  array(
                    'VALUE' => $this->my_config['prefix'],
                    'F_ACTION' => 'DmPanier.php?action=genfic',
                )
              );
  }

  /* Si la page est recharg par le bouton "Supprimer"
  * du formulaire il ne faut pas recrer les fichiers */
  function DmPanierGenZip($prefix)
  {
    global $prefixeTable, $user, $conf;
    
    $dir_zip = $this->plugin_path.'/zip_archive/'.$user['id'].'/';
    
    // Slection des photos par rapport  l'id utilisateur
    $query = '
        SELECT id_image, filesize, type FROM '.$prefixeTable.'download_multi
        WHERE id_user = '.$user['id'].'
    ;';
    $result = pwg_query($query);

    // Si aucun prfix n'est envoy
    // il est automatiquement attribu a
    // la valeur par dfaut dfinit dans la partie administration
    if ($prefix == '')
    {
      $prefix = $this->my_config['prefix'];
    }
    else
    {
      // Contrle les caractres spciaux
      // et les remplaces par un valeur correcte
      $accents = "ABCDEFGHIJKLMNOPQRSTUVWXYZǎƄ噝䔛Ԑӊ؍ꚗ :,.;?!~'()/&%*\"$[]{}|";
      $ssaccents = "abcdefghijklmnopqrstuvwxyzAAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn_______________________";
      $prefix = strtr( $prefix, $accents, $ssaccents );
    }

    // Si le nombre d'enregistrement est gale 
    // 0, alors il n'y a pas de fichier propos au tlchargement
    if (mysql_num_rows($result) != 0)
    {
      require($this->plugin_path.'/include/pclzip.lib.php'); // inclusion de la librairie pour la compression zip
      $id_file = rand(1, 2000);
      $nom_fichier = $prefix.$id_file.'.zip'; // nom du fichier zip
      $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accs au fichier zip
      $archive = new PclZip($fichier_zip);
      $fic_size = 0; // Initialisation de la taille

      while ($row = mysql_fetch_array($result))
      {
        // Slection des informations ncessaire pour
        // gnrer le fichier zip
        $query_1 = '
          SELECT file, path
          FROM '.IMAGES_TABLE.'
          WHERE id = \''.$row['id_image'].'\'
        ;';
        $row_1 = mysql_fetch_array(pwg_query($query_1));

        $ficdir = '../../.'.dirname($row_1['path']);

        if($row['type'] == 't')
        {
          $fic_insert = $ficdir.'/thumbnail/'.$conf['prefix_thumbnail'].$row_1['file'];
        }
        if($row['type'] == 'n')
        {
          $fic_insert = $ficdir.'/'.$row_1['file'];
        }
        if($row['type'] == 'h')
        {
          $fic_insert = $ficdir.'/pwg_high/'.$row_1['file'];
        }

        // Taille de l'archive
        // si l'archive est plus petite que la valeur dfinit
        // le mme fichier est utilis
        if ( $fic_size < $this->my_config['archive_size'] )
        {
          if( $this->my_config['active_msg'] )
          {
            $v_list = $archive->add($fic_insert,
                                  PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
                                  PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir'],
                                  PCLZIP_OPT_COMMENT, $this->my_config['comment']
                                );
          }
          else
          {
            $v_list = $archive->add($fic_insert,
                                  PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
                                  PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir']
                                );
          }
          if ($v_list == 0)
          {
            die('Erreur : '.$archive->errorInfo(true));
          }
        }
        // Si l'archive est plus grande que la valeur dfinit
        // un nouveau fichier est cr.
        else
        {
          $id_file = rand(1, 2000);
          $nom_fichier = $prefix.$id_file.'.zip'; // nom du fichier zip
          $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accs au fichier zip
          $archive = new PclZip($fichier_zip);
          $fic_size = 0; // Initialisation de la taille
          if( $this->my_config['active_msg'] )
          {
            $v_list = $archive->add($fic_insert,
                                  PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
                                  PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir'],
                                  PCLZIP_OPT_COMMENT, $this->my_config['comment']
                                );
          }
          else
          {
            $v_list = $archive->add($fic_insert,
                                  PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
                                  PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir']
                                );
          }
          if ($v_list == 0)
          {
            die('Erreur : '.$archive->errorInfo(true));
          }
        }
        $fic_size = $row['filesize'] + $fic_size;
      }
    }

  // Liste le rpertoire de l'utlilisateur
  $this->DmPanierListeDir();
  clearstatcache();
  }

  /* Liste le rpertoire utilisateur */
  function DmPanierListeDir()
  {
    global $user, $template;
    $dir_zip = $this->plugin_path.'/zip_archive/'.$user['id'].'/';

    $dir = opendir($dir_zip);
    while($file = readdir($dir))
    {
      if(!is_file($file) && $file != '.' && $file != '..')
      {
        $tab_file[] = array('file' => $file, 'date' => filemtime($dir_zip.$file));
      }
    }

    if (isset($tab_file))
    {
      $template->assign_block_vars(
                  'telechargement.formulaire',
                    array(
                      'F_ACTION' => 'DmPanier.php?action=del'
                    )
                );

      // Obtient une liste de colonnes
      foreach ($tab_file as $key => $row)
      {
        $file[$key]  = $row['file'];
        $date[$key] = $row['date'];
      }

      // Tri les donnes par volume dcroissant, edition croissant
      // Ajoute $data en tant que dernier paramtre, pour trier par la cl commune
      array_multisort($file, SORT_ASC, $date, SORT_DESC, $tab_file);

      foreach($tab_file as $elem)
      {
        $template->assign_block_vars(
                    'telechargement.formulaire.list',
                      array(
                        'FIC_CHEMIN' => $this->plugin_url.'plugins/'.$this->plugin_name.'/zip_archive/'.$user['id'].'/',
                        'FIC_NAME' => $elem['file'],
                        'FIC_DATE' => $this->DmPanierDd($elem['date'])
                      )
                    );
      }
    }
    else
    {
      $template->assign_block_vars('telechargement.error', array());
    }
    closedir($dir);
    clearstatcache();
  }

  /* Suppression des fichiers dans le
  *  rpertoire utilisateur
  *  $fic --> liste des fichiers  */
  function DmPanierDelUserDir($fic)
  {
    global $user, $prefixeTable;
    if (isset($fic))
    {
      for($i=0;$i<count($fic);$i++)
      {
        unlink($this->plugin_path.'/zip_archive/'.$user['id'].'/'.$fic[$i]);
      }
    }
    
    // Suppression des images slectionn dans une prcdente session
    $query = '
      DELETE FROM '.$prefixeTable.'download_multi
      WHERE id_user = \''.$user['id'].'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour viter la fragmentation
    // aprs suppression d'enregistrements
    $query = '
      OPTIMIZE TABLE '.$prefixeTable.'download_multi
    ;';
    $result = pwg_query($query);
    
    $this->DmPanierListeDir();
    clearstatcache();
  }

  /* Renvoie la date */
  function DmPanierDd($date)
  {
    return date("d/m/Y H:i:s", $date);
  }
/* ------- Fin de la page DmPanier.php ------ */

/* ------- Section pour le fichier DmPreview.php ------ */

  /* Affiche la liste des images */
  function DmPreviewList()
  {
    global $prefixeTable, $user, $template, $conf, $lang;
    $query = '
      SELECT id_image, type
      FROM '.$prefixeTable.'download_multi
      WHERE id_user = '.$user['id'].'
    ;';
    $result = pwg_query($query);
    
    // Si il n'y a pas d'enregistrement
    // Affiche le message 'panier vide'
    if (mysql_num_rows($result) == 0)
    {
      $template->assign_block_vars(
        'preview.empty',
          array(
            'EMPTY' => $lang['dl_empty_cart']
            )
          );
    }
    else
    {
      while ($row = mysql_fetch_array($result))
      {
        // Slection des informations par rapport  l'id image
        $query_1 = '
          SELECT file, path
          FROM '.IMAGES_TABLE.'
          WHERE id = \''.$row['id_image'].'\'
        ;';
        $row_1 = mysql_fetch_array(pwg_query($query_1));

        // Rcupration du rpertoire
        $path = dirname(substr($row_1['path'], 2));

        // Gnration du nom
        $file = $conf['prefix_thumbnail'].$row_1['file'];
        $type = $row['type'];
        $chemin = get_root_url().$path.'/thumbnail/'.$file;

        switch ($type)
        {
          case 't':
            $txt_type = $lang['dl_type_thumbnail'];
            $img_type = 'page_white_world.png';
          break;
          case 'n':
            $txt_type = $lang['dl_type_normal'];
            $img_type = 'page_white_picture.png';
          break;
          case 'h':
            $txt_type = $lang['dl_type_high'];
            $img_type = 'page_white_camera.png';
          break;
        }

        $template->assign_block_vars(
            'preview.image',
              array(
                'F_ID_IMAGE' => $row['id_image'],
                'F_TYPE' => $type,
                'PATH' => $chemin,
                'NAME' => $file,
                'TYPE' => $txt_type,
                'IMG' => $img_type
              )
            );
      }
    }
  }
  
  /* Supprime une image
  * id_image -> identifiant de l'image
  * type -> type de l'image */
  function DmPreviewDel($id_image, $type)
  {
    global $prefixeTable;
    // Suppression d'une image par rapport  sont id
    $query = '
      DELETE FROM '.$prefixeTable.'download_multi
      WHERE id_image = \''.$id_image.'\'
      AND type = \''.$type.'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour viter la fragmentation
    // aprs suppression d'enregistrements
    $query = '
      OPTIMIZE TABLE '.$prefixeTable.'download_multi
    ;';

    $result = pwg_query($query);
  }
/* ------- Fin de la page DmPreview.php ------ */

/* ------- Administration ------- */

  // Affiche une liste de groupe
  function DmSelectGroup($DmGroupId)
  {
    global $template, $prefixeTable;
    $selected = '';

    $query = 'SELECT * FROM '.$prefixeTable.'groups;';
    $result = pwg_query($query);
    while ($row = mysql_fetch_array($result))
    {
      // Si l'identifiant envoy par le formulaire
      // ou celui dj enregistr dans la configuration
      // et celui rcupr en base alors
      // la valeur est slectionn pour le formulaire
      if ($DmGroupId == $row['id'] OR $this->my_config['group_id'] == $row['id'])
      {
        $selected = ' selected="selected"';
      }
      $template->assign_block_vars(
        'DmGroup',
          array(
            'ID' => $row['id'],
            'NAME' => $row['name'],
            'SELECTED' => $selected
          )
        );
      $selected = '';
    }
  }
}
?>
